<?php
/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 16/11/2016
 * Time: 16:31
 */

namespace ByDedi\AdminBundle\Controller;

use ByDedi\AdminBundle\Entity\UserBookmark;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class BookmarkController extends Controller
{

    /**
     * @Route(
     *      path         = "/bookmark/add",
     *      name         = "bookmark_add"
     * )
     * @return mixed
     *
     */
    public function add()
    {
        $request = $this->getRequest();
        $router = $this->get('router');

        $json = ['status' => false, 'message' => ''];
        $currentUrl = $request->get('url');

        if (empty($currentUrl)) {
            exit();
        }


        $user = $this->get('security.token_storage')->getToken()->getUser();

        $em = $this->get('doctrine.orm.entity_manager');
        $userBmRepo = $em->getRepository('AdminBundle:UserBookmark');

        $exist = $userBmRepo->findOneBy(['user' => $user,'url' => $currentUrl]);

        if (empty($exist)) {
            $route = $router->match($currentUrl);
            $title = $currentUrl;
            if (!empty($route)) {
                $admin = $this->get($route['_sonata_admin']);
                if (strpos($route['_route'], '_create') !== false) {
                    $title = 'Ajouter : ';
                } elseif (strpos($route['_route'], '_list') !== false) {
                    $title = 'Liste : ';
                } elseif (strpos($route['_route'], '_edit') !== false) {
                    $title = 'Editer #'.$route['id'].' : ';
                }
                $title.= $admin->getLabel();
            }

            $bookmark = new UserBookmark();
            $bookmark->setUser($user);
            $bookmark->setUrl($currentUrl);
            $bookmark->setTitle($title);
            $em->persist($bookmark);

            $json['status'] = true;
        } else {
            $json['status'] = true;
            $em->remove($exist);
        }
        $em->flush();

        return new JsonResponse($json);
    }


    /**
     * @return Request
     */
    public function getRequest()
    {
        if ($this->container->has('request_stack')) {
            return $this->container->get('request_stack')->getCurrentRequest();
        }

        return $this->container->get('request');
    }
}
